<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
include_once $path.'/Model_adm.php';
//on récupère le nom du serveur
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
 'name'=>$node->getName(),
 'ip'=>$node->getIPAddress(),
 'id'=>$node->getId(),
 'description'=>$node->getDescription(),
 'group'=>$node->getGroup());
 * SMARTY
 $webp_name nom du plugin
 $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
$webp_name = 'FLOWS';
include_once $path.'/inc/common_node_control.php';
include_once $path.$apache_plugin_path.'libs/flowServer.class.php';
$tab = '';
if(isset($_GET['tab']) && !empty($_GET['tab']))
{
	$tab = $_GET['tab'];
}
$smarty->assign('tab', $tab);
session_write_close();
$node = new FlowServer($node);
$setting = Model_esia::getAdvanceNodeConfig($dbconnection, $node->getId(), 'FLOW_CHANNEL')[0];
if(!empty($setting))
{
	$flowServer = Model_esia::InstanceNode($dbconnection, $setting['parameter']['flows-server']);
	$smarty->assign('channel', $setting['parameter']['channel']);
	$flowServer = new FlowServer($flowServer);
	$setting = Model_adm::getAdvanceNodeConfig($dbconnection,$flowServer->getId(),'FLOWS')[0];
	$flowServer->setURL($setting['parameter']['url']); 
	$smarty->assign('server', array('id' => $flowServer->getId(),'name' => $flowServer->getName() ));
	$arr = Model_esia::getWebPlugin($dbconnection,FALSE,'FLOWS');
	$apache_flows_path = $arr[0]['apache_path'];
	$smarty->assign('apache_flows_path', $apache_flows_path);
	
	$smarty->display($template_path.'adv_tab_flows.html');
}
else
{
	$smarty->display('no_access.html');
	exit(0);
}
?>