<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */
$path = $_SERVER['DOCUMENT_ROOT'];
// $webp_name doit être identique au nom de la base de données !!!
$webp_name='FLOWS'; 
//$webp_model='model_'.$webp_name.'.php'; 
//Inclusion des librairie
include_once $path.'common.php';
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
                    'name'=>$node->getName(),
				    'ip'=>$node->getIPAddress(),
				    'id'=>$node->getId(),
				    'description'=>$node->getDescription(),
				    'group'=>$node->getGroup());
 * SMARTY
        $webp_name nom du plugin 
        $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
include_once $path.'/inc/common_node_control.php';
include_once $path . $apache_plugin_path . '/libs/flowServer.class.php';
//Variable passé en paramètre
$tab='';
if(isset($_GET['tab'])&& !empty($_GET['tab']))
{
	$tab=$_GET['tab'];
}
$action='';
if(isset($_GET['action'])&& !empty($_GET['action']))
{
	$action=$_GET['action'];
}
$smarty->assign('tab', $tab);


session_write_close();
try
{
    if($tab=='servicestate')
    {
        $services = model_esia::getServices($dbconnection,$node->getId());
        $disk = array();
        $mem= array('value'=>-1,'warning'=>100,'critical'=>100);
        $load= array('value'=>-1,'warning'=>100,'critical'=>100);
        foreach($services as $ser)
        {
            if(strpos($ser['check_plugin_name'],'LOAD')!==FALSE)
            {
                if(preg_match('#\-w\s+([0-9]*)#',$ser['parameter'],$regs))
                {
                	$load['warning']=$regs[1];
                }
                if(preg_match('#\-c\s+([0-9]*)#',$ser['parameter'],$regs))
                {
                	$load['critical']=$regs[1];
                }
                $load['value']=$ser['value']['cpu'];
            }
            elseif(strpos($ser['check_plugin_name'],'MEM')!==FALSE)
            {
                if(preg_match('#\-w\s+([0-9]*)#',$ser['parameter'],$regs))
                {
                	$mem['warning']=$regs[1];
                }
                if(preg_match('#\-c\s+([0-9]*)#',$ser['parameter'],$regs))
                {
                	$mem['critical']=$regs[1];
                }
                $mem['value']=$ser['value']['ram'];
            }
            elseif(strpos($ser['check_plugin_name'],'STORAGE')!==FALSE)
            {
				$common_name = Model_esia::getCommonName($lang,$ser['name'],$ser['check_plugin_name']);
                $disk[] = array('name'=>$common_name,'value'=> $ser['value']['hdd'],'state'=>$ser['real_state']);
            }
        }
        $smarty->assign('ram_information',$mem);
        $smarty->assign('disk_informations',$disk);
        $smarty->assign('cpu_information',$load);
    }
    elseif($tab=='channel-detail')
    {
    	$subtab='';
    	if(isset($_GET['subtab'])&& !empty($_GET['subtab']))
    	{
    		$subtab=$_GET['subtab'];
    	}
    	$node = new FlowServer($node);
    	$setting = Model_esia::getAdvanceNodeConfig($dbconnection, $node->getId(), 'FLOWS')[0];
    	$node->setURL($setting['parameter']['url']);
    	$arr = $node->getCollector(null,FlowServer::OUTPUT_ARRAY);
    	$smarty->assign('collectors',$arr);
    	/*if($subtab=='collectors')
    	{
    	    $arr = $node->getCollector(null,FlowServer::OUTPUT_ARRAY);
    		$smarty->assign('collectors',$arr);
    	}
        elseif($subtab=='show')
        {
        }*/
    	$smarty->assign('subtab',$subtab);
    }
    elseif($tab=='channel')
    {
    	$subtab='';
    	if(isset($_GET['subtab'])&& !empty($_GET['subtab']))
    	{
    		$subtab=$_GET['subtab'];
    	}
    	$node = new FlowServer($node);
    	$setting = Model_esia::getAdvanceNodeConfig($dbconnection, $node->getId(), 'FLOWS')[0];
    	$node->setURL($setting['parameter']['url']);
    	if($subtab=='configuration')
    	{
    		$channel = $node->getChannel(null,FlowServer::OUTPUT_ARRAY);
    		$smarty->assign('channels',$channel);
    	}
    	
    	$smarty->assign('subtab',$subtab);
    }
    elseif($tab=='configuration')
    {
    	$node = new FlowServer($node);
    	$setting = Model_esia::getAdvanceNodeConfig($dbconnection, $node->getId(), 'FLOWS')[0];
    	$node->setURL($setting['parameter']['url']);
    	$smarty->assign('flow_conf',array('raw_data'=>30));
    }
}
//Traitement des exceptions SNMP et des erreurs de traitement dans la base de donnée
catch(DeviceNotAliveException $e)
{
	$smarty->assign('errors','no');
}
catch(DeviceSNMPException $e)
{
	$smarty->assign('errors',$lang['ADM_ERR_SNMP_FAILED']);
}
catch(DeviceException $e)
{
	$smarty->assign('errors',$e->getMessage());
}
$smarty->display($template_path.'control_flows.html');
?>
