<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */

//inclusion des fichiers principaux

//$ESIA_WIDGET_NOTREE=TRUE;
$webp_name='FLOWS'; 
//$webp_model='model_'.$webp_name.'.php'; 

$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
//Inclusion des librairie
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
                    'name'=>$node->getName(),
				    'ip'=>$node->getIPAddress(),
				    'id'=>$node->getId(),
				    'description'=>$node->getDescription(),
				    'group'=>$node->getGroup());
 * SMARTY 
        $node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 */
include_once $path.'/inc/common_node_control.php';
include_once $path.'/Model_adm.php';
include_once $path . $apache_plugin_path . '/libs/flowServer.class.php';
$node = new FlowServer($node);
$setting = Model_esia::getAdvanceNodeConfig($dbconnection, $node->getId(), 'FLOWS')[0];
$node->setURL($setting['parameter']['url']);
$smarty->assign('lang',  $lang);
//valeur par défaut
$action ="showCollector";
if(!empty($_GET['action']))
{
    $action =$_GET['action'];
}
$smarty->assign('action',$action);
session_write_close();
if($action == "showCollector" )
{
    if(!empty($_GET['collector']))
    {
    	$dataid=null;
    	$collector =$_GET['collector'];
    	if(!empty($_GET['dataid']))
    	{
    		$dataid=$_GET['dataid'];
    		$arr = $node->getDataCollector($collector,$dataid,FlowServer::OUTPUT_ARRAY);
    		echo json_encode($arr[0]);
    		exit(0);
    	}
    	else
    	{
    		$smarty->assign('collector_id',$collector);
    		$arr = $node->getDataCollector($collector,null,FlowServer::OUTPUT_ARRAY);
    		$datatime = array();
    		$data = array();
    		$smarty->assign('header_translate',json_encode($lang['FLOWS_COLLECTOR_HEADER'],true));
    		foreach($arr as $line)
    		{
    			$id = $line['id'];
    			$date = new DateTime($line['time']);
    			$datatime[$id]= $date->format('d-m-Y H:i:s');
    		}
    		$smarty->assign('datatime', array_reverse($datatime, true));
    	}
    }        
}
elseif($action == "addCollector" || $action == "updateCollector")
{
	if(!empty($_POST['collector_name']))
	{
		$name=$_POST['collector_name'];
		$path=$_POST['collector_path'];
		$param=$_POST['collector_param'];
		$interval=$_POST['collector_interval'];
		$retention=$_POST['collector_retention'];
		//Ajouter les appel pour la mise à jour après le retravaille de la base de données
	}
	if(!empty($_GET['collector']))
	{
		$collector =$_GET['collector'];
		$smarty->assign('collector_id',$collector);
		$colects = $node->getCollectorPlugin($collector,FlowServer::OUTPUT_ARRAY);		
		$cols = $colects[$collector];
		$smarty->assign('collector',$cols);
		$retention = $cols['retentionday'];
		$interval = $cols['interval_second']/60;
	}
	else 
	{
		$colects = $node->getCollectorPlugin('all',FlowServer::OUTPUT_ARRAY);
		$retention = 30;
		$interval=60;
	}
	$smarty->assign('collector_id',$collector);

//	echo '<pre>';print_r($arr);
	$plugin = array();
	$listexec = array();
	foreach($colects as $col)
	{
		if(! in_array($col['path'],$listexec))
		{
			$listexec[]=$col['path'];
			$exec = preg_replace('#/usr/local/esia/plugins/#','', $col['path']);
			$plugin[$col['id']] = array('exec'=>$exec, 'path'=>$col['path'], 'id'=>$col['id'],'parameter'=>$col['parameter']);
		}
	}
	$list_collectors=array();
	$smarty->assign('retention',$retention);
	$smarty->assign('interval',$interval);
	$smarty->assign('collector_exec',$plugin);
	/*if(!empty($_GET['collector']))
	{
		$collector =$_GET['collector'];
		$arr = $node->getCollector($collector,FlowServer::OUTPUT_ARRAY);
		$arr = $arr[$collector];
		//TO DO à Optimiser
		$smarty->assign('collector',$arr);
	}*/
}
elseif($action == "deleteCollector" )
{
    if(!empty($_GET['collector']))
    {
        $collector =$_GET['collector'];
    	$arr = $node->getCollector($collector,FlowServer::OUTPUT_ARRAY);
        $arr = $arr[$collector];
        //TO DO à Optimiser
    	$smarty->assign('collector',$arr);
    }
}
elseif($action == "addChannel" || $action == "updateChannel")
{
    if(!empty($_GET['channel']))
    {
        $channel =$_GET['channel'];
    	$arr = $node->getChannel($channel,FlowServer::OUTPUT_ARRAY);
    	$smarty->assign('channel',$arr);
    }
    if(!empty($_POST['channel_name']))
    {
    	$name = $_POST['channel_name'];
    	$protocol= $_POST['channel_protocol'];
    	$port = $_POST['channel_port'];
    	$ip = $_POST['channel_ip'];
    	//update
    	if(!empty($_POST['channel_id']))
    	{
    		//Update
    		$smarty->assign('success_message',$lang['FLOWS_SRV_CHANNEL_UPDATE_SUCCESS']);
    	}
    	else
    	{
    		//add
    		$smarty->assign('success_message',$lang['FLOWS_SRV_CHANNEL_ADD_SUCCESS']);
    	}
    	$arr = $node->getChannel($channel,FlowServer::OUTPUT_ARRAY);
    	$smarty->assign('channel',array('ip_dist'=>$ip,'name'=>$name,'protocol'=>$protocol,'port'=>$port));
    }
    
}
elseif($action == "deleteChannel" )
{
    if(!empty($_GET['channel']))
    {
        $channel =$_GET['channel'];
    	$arr = $node->getChannel($channel,FlowServer::OUTPUT_ARRAY);
    	$smarty->assign('channel',$arr);
    }
}
else
{
    echo "Action not found\n";
}
$smarty->display($template_path.'dialog_flows.html');
?>
